<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEstadosBE ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEstadosBE
 * @subpackage Arrays
 */
class ArrayOfEstadosBE extends AbstractStructArrayBase
{
    /**
     * The EstadosBE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\StructType\EstadosBE[]
     */
    public $EstadosBE;
    /**
     * Constructor method for ArrayOfEstadosBE
     * @uses ArrayOfEstadosBE::setEstadosBE()
     * @param \LGRAVE\StructType\EstadosBE[] $estadosBE
     */
    public function __construct(array $estadosBE = array())
    {
        $this
            ->setEstadosBE($estadosBE);
    }
    /**
     * Get EstadosBE value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\StructType\EstadosBE[]|null
     */
    public function getEstadosBE()
    {
        return isset($this->EstadosBE) ? $this->EstadosBE : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEstadosBE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEstadosBE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEstadosBEForArrayConstraintsFromSetEstadosBE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEstadosBEEstadosBEItem) {
            // validation for constraint: itemType
            if (!$arrayOfEstadosBEEstadosBEItem instanceof \LGRAVE\StructType\EstadosBE) {
                $invalidValues[] = is_object($arrayOfEstadosBEEstadosBEItem) ? get_class($arrayOfEstadosBEEstadosBEItem) : sprintf('%s(%s)', gettype($arrayOfEstadosBEEstadosBEItem), var_export($arrayOfEstadosBEEstadosBEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EstadosBE property can only contain items of type \LGRAVE\StructType\EstadosBE, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EstadosBE value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\EstadosBE[] $estadosBE
     * @return \LGRAVE\ArrayType\ArrayOfEstadosBE
     */
    public function setEstadosBE(array $estadosBE = array())
    {
        // validation for constraint: array
        if ('' !== ($estadosBEArrayErrorMessage = self::validateEstadosBEForArrayConstraintsFromSetEstadosBE($estadosBE))) {
            throw new \InvalidArgumentException($estadosBEArrayErrorMessage, __LINE__);
        }
        if (is_null($estadosBE) || (is_array($estadosBE) && empty($estadosBE))) {
            unset($this->EstadosBE);
        } else {
            $this->EstadosBE = $estadosBE;
        }
        return $this;
    }
    /**
     * Add item to EstadosBE value
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\EstadosBE $item
     * @return \LGRAVE\ArrayType\ArrayOfEstadosBE
     */
    public function addToEstadosBE(\LGRAVE\StructType\EstadosBE $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LGRAVE\StructType\EstadosBE) {
            throw new \InvalidArgumentException(sprintf('The EstadosBE property can only contain items of type \LGRAVE\StructType\EstadosBE, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EstadosBE[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LGRAVE\StructType\EstadosBE|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LGRAVE\StructType\EstadosBE|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LGRAVE\StructType\EstadosBE|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LGRAVE\StructType\EstadosBE|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LGRAVE\StructType\EstadosBE|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EstadosBE
     */
    public function getAttributeName()
    {
        return 'EstadosBE';
    }
}
