<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPickUpData.Destinations ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPickUpData.Destinations
 * @subpackage Arrays
 */
class ArrayOfPickUpData_Destinations extends AbstractStructArrayBase
{
    /**
     * The PickUpData_Destinations
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $PickUpData_Destinations;
    /**
     * Constructor method for ArrayOfPickUpData.Destinations
     * @uses ArrayOfPickUpData_Destinations::setPickUpData_Destinations()
     * @param string[] $pickUpData_Destinations
     */
    public function __construct(array $pickUpData_Destinations = array())
    {
        $this
            ->setPickUpData_Destinations($pickUpData_Destinations);
    }
    /**
     * Get PickUpData_Destinations value
     * @return string[]|null
     */
    public function getPickUpData_Destinations()
    {
        return $this->{'PickUpData.Destinations'};
    }
    /**
     * This method is responsible for validating the values passed to the setPickUpData_Destinations method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPickUpData_Destinations method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePickUpData_DestinationsForArrayConstraintsFromSetPickUpData_Destinations(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPickUpData_DestinationsPickUpData_DestinationsItem) {
            // validation for constraint: enumeration
            if (!\LGRAVE\EnumType\PickUpData_Destinations::valueIsValid($arrayOfPickUpData_DestinationsPickUpData_DestinationsItem)) {
                $invalidValues[] = is_object($arrayOfPickUpData_DestinationsPickUpData_DestinationsItem) ? get_class($arrayOfPickUpData_DestinationsPickUpData_DestinationsItem) : sprintf('%s(%s)', gettype($arrayOfPickUpData_DestinationsPickUpData_DestinationsItem), var_export($arrayOfPickUpData_DestinationsPickUpData_DestinationsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \LGRAVE\EnumType\PickUpData_Destinations', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \LGRAVE\EnumType\PickUpData_Destinations::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PickUpData_Destinations value
     * @uses \LGRAVE\EnumType\PickUpData_Destinations::valueIsValid()
     * @uses \LGRAVE\EnumType\PickUpData_Destinations::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $pickUpData_Destinations
     * @return \LGRAVE\ArrayType\ArrayOfPickUpData_Destinations
     */
    public function setPickUpData_Destinations(array $pickUpData_Destinations = array())
    {
        // validation for constraint: array
        if ('' !== ($pickUpData_DestinationsArrayErrorMessage = self::validatePickUpData_DestinationsForArrayConstraintsFromSetPickUpData_Destinations($pickUpData_Destinations))) {
            throw new \InvalidArgumentException($pickUpData_DestinationsArrayErrorMessage, __LINE__);
        }
        $this->PickUpData_Destinations = $this->{'PickUpData.Destinations'} = $pickUpData_Destinations;
        return $this;
    }
    /**
     * Add item to PickUpData_Destinations value
     * @uses \LGRAVE\EnumType\PickUpData_Destinations::valueIsValid()
     * @uses \LGRAVE\EnumType\PickUpData_Destinations::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \LGRAVE\ArrayType\ArrayOfPickUpData_Destinations
     */
    public function addToPickUpData_Destinations($item)
    {
        // validation for constraint: enumeration
        if (!\LGRAVE\EnumType\PickUpData_Destinations::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \LGRAVE\EnumType\PickUpData_Destinations', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \LGRAVE\EnumType\PickUpData_Destinations::getValidValues())), __LINE__);
        }
        $this->PickUpData_Destinations[] = $this->{'PickUpData.Destinations'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \LGRAVE\EnumType\PickUpData_Destinations::valueIsValid()
     * @param string $item
     * @return \LGRAVE\ArrayType\ArrayOfPickUpData_Destinations
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\LGRAVE\EnumType\PickUpData_Destinations::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \LGRAVE\EnumType\PickUpData_Destinations', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \LGRAVE\EnumType\PickUpData_Destinations::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PickUpData.Destinations
     */
    public function getAttributeName()
    {
        return 'PickUpData.Destinations';
    }
}
