<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPickUpModel.Destinations ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPickUpModel.Destinations
 * @subpackage Arrays
 */
class ArrayOfPickUpModel_Destinations extends AbstractStructArrayBase
{
    /**
     * The PickUpModel_Destinations
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $PickUpModel_Destinations;
    /**
     * Constructor method for ArrayOfPickUpModel.Destinations
     * @uses ArrayOfPickUpModel_Destinations::setPickUpModel_Destinations()
     * @param string[] $pickUpModel_Destinations
     */
    public function __construct(array $pickUpModel_Destinations = array())
    {
        $this
            ->setPickUpModel_Destinations($pickUpModel_Destinations);
    }
    /**
     * Get PickUpModel_Destinations value
     * @return string[]|null
     */
    public function getPickUpModel_Destinations()
    {
        return $this->{'PickUpModel.Destinations'};
    }
    /**
     * This method is responsible for validating the values passed to the setPickUpModel_Destinations method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPickUpModel_Destinations method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePickUpModel_DestinationsForArrayConstraintsFromSetPickUpModel_Destinations(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPickUpModel_DestinationsPickUpModel_DestinationsItem) {
            // validation for constraint: enumeration
            if (!\LGRAVE\EnumType\PickUpModel_Destinations::valueIsValid($arrayOfPickUpModel_DestinationsPickUpModel_DestinationsItem)) {
                $invalidValues[] = is_object($arrayOfPickUpModel_DestinationsPickUpModel_DestinationsItem) ? get_class($arrayOfPickUpModel_DestinationsPickUpModel_DestinationsItem) : sprintf('%s(%s)', gettype($arrayOfPickUpModel_DestinationsPickUpModel_DestinationsItem), var_export($arrayOfPickUpModel_DestinationsPickUpModel_DestinationsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \LGRAVE\EnumType\PickUpModel_Destinations', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \LGRAVE\EnumType\PickUpModel_Destinations::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PickUpModel_Destinations value
     * @uses \LGRAVE\EnumType\PickUpModel_Destinations::valueIsValid()
     * @uses \LGRAVE\EnumType\PickUpModel_Destinations::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $pickUpModel_Destinations
     * @return \LGRAVE\ArrayType\ArrayOfPickUpModel_Destinations
     */
    public function setPickUpModel_Destinations(array $pickUpModel_Destinations = array())
    {
        // validation for constraint: array
        if ('' !== ($pickUpModel_DestinationsArrayErrorMessage = self::validatePickUpModel_DestinationsForArrayConstraintsFromSetPickUpModel_Destinations($pickUpModel_Destinations))) {
            throw new \InvalidArgumentException($pickUpModel_DestinationsArrayErrorMessage, __LINE__);
        }
        $this->PickUpModel_Destinations = $this->{'PickUpModel.Destinations'} = $pickUpModel_Destinations;
        return $this;
    }
    /**
     * Add item to PickUpModel_Destinations value
     * @uses \LGRAVE\EnumType\PickUpModel_Destinations::valueIsValid()
     * @uses \LGRAVE\EnumType\PickUpModel_Destinations::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \LGRAVE\ArrayType\ArrayOfPickUpModel_Destinations
     */
    public function addToPickUpModel_Destinations($item)
    {
        // validation for constraint: enumeration
        if (!\LGRAVE\EnumType\PickUpModel_Destinations::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \LGRAVE\EnumType\PickUpModel_Destinations', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \LGRAVE\EnumType\PickUpModel_Destinations::getValidValues())), __LINE__);
        }
        $this->PickUpModel_Destinations[] = $this->{'PickUpModel.Destinations'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \LGRAVE\EnumType\PickUpModel_Destinations::valueIsValid()
     * @param string $item
     * @return \LGRAVE\ArrayType\ArrayOfPickUpModel_Destinations
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\LGRAVE\EnumType\PickUpModel_Destinations::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \LGRAVE\EnumType\PickUpModel_Destinations', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \LGRAVE\EnumType\PickUpModel_Destinations::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PickUpModel.Destinations
     */
    public function getAttributeName()
    {
        return 'PickUpModel.Destinations';
    }
}
