<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProdutosBE ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProdutosBE
 * @subpackage Arrays
 */
class ArrayOfProdutosBE extends AbstractStructArrayBase
{
    /**
     * The ProdutosBE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\StructType\ProdutosBE[]
     */
    public $ProdutosBE;
    /**
     * Constructor method for ArrayOfProdutosBE
     * @uses ArrayOfProdutosBE::setProdutosBE()
     * @param \LGRAVE\StructType\ProdutosBE[] $produtosBE
     */
    public function __construct(array $produtosBE = array())
    {
        $this
            ->setProdutosBE($produtosBE);
    }
    /**
     * Get ProdutosBE value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\StructType\ProdutosBE[]|null
     */
    public function getProdutosBE()
    {
        return isset($this->ProdutosBE) ? $this->ProdutosBE : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProdutosBE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProdutosBE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProdutosBEForArrayConstraintsFromSetProdutosBE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProdutosBEProdutosBEItem) {
            // validation for constraint: itemType
            if (!$arrayOfProdutosBEProdutosBEItem instanceof \LGRAVE\StructType\ProdutosBE) {
                $invalidValues[] = is_object($arrayOfProdutosBEProdutosBEItem) ? get_class($arrayOfProdutosBEProdutosBEItem) : sprintf('%s(%s)', gettype($arrayOfProdutosBEProdutosBEItem), var_export($arrayOfProdutosBEProdutosBEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProdutosBE property can only contain items of type \LGRAVE\StructType\ProdutosBE, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProdutosBE value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\ProdutosBE[] $produtosBE
     * @return \LGRAVE\ArrayType\ArrayOfProdutosBE
     */
    public function setProdutosBE(array $produtosBE = array())
    {
        // validation for constraint: array
        if ('' !== ($produtosBEArrayErrorMessage = self::validateProdutosBEForArrayConstraintsFromSetProdutosBE($produtosBE))) {
            throw new \InvalidArgumentException($produtosBEArrayErrorMessage, __LINE__);
        }
        if (is_null($produtosBE) || (is_array($produtosBE) && empty($produtosBE))) {
            unset($this->ProdutosBE);
        } else {
            $this->ProdutosBE = $produtosBE;
        }
        return $this;
    }
    /**
     * Add item to ProdutosBE value
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\ProdutosBE $item
     * @return \LGRAVE\ArrayType\ArrayOfProdutosBE
     */
    public function addToProdutosBE(\LGRAVE\StructType\ProdutosBE $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LGRAVE\StructType\ProdutosBE) {
            throw new \InvalidArgumentException(sprintf('The ProdutosBE property can only contain items of type \LGRAVE\StructType\ProdutosBE, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProdutosBE[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LGRAVE\StructType\ProdutosBE|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LGRAVE\StructType\ProdutosBE|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LGRAVE\StructType\ProdutosBE|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LGRAVE\StructType\ProdutosBE|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LGRAVE\StructType\ProdutosBE|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProdutosBE
     */
    public function getAttributeName()
    {
        return 'ProdutosBE';
    }
}
