<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServicoEspecial ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfServicoEspecial
 * @subpackage Arrays
 */
class ArrayOfServicoEspecial extends AbstractStructArrayBase
{
    /**
     * The ServicoEspecial
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\StructType\ServicoEspecial[]
     */
    public $ServicoEspecial;
    /**
     * Constructor method for ArrayOfServicoEspecial
     * @uses ArrayOfServicoEspecial::setServicoEspecial()
     * @param \LGRAVE\StructType\ServicoEspecial[] $servicoEspecial
     */
    public function __construct(array $servicoEspecial = array())
    {
        $this
            ->setServicoEspecial($servicoEspecial);
    }
    /**
     * Get ServicoEspecial value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\StructType\ServicoEspecial[]|null
     */
    public function getServicoEspecial()
    {
        return isset($this->ServicoEspecial) ? $this->ServicoEspecial : null;
    }
    /**
     * This method is responsible for validating the values passed to the setServicoEspecial method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServicoEspecial method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServicoEspecialForArrayConstraintsFromSetServicoEspecial(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfServicoEspecialServicoEspecialItem) {
            // validation for constraint: itemType
            if (!$arrayOfServicoEspecialServicoEspecialItem instanceof \LGRAVE\StructType\ServicoEspecial) {
                $invalidValues[] = is_object($arrayOfServicoEspecialServicoEspecialItem) ? get_class($arrayOfServicoEspecialServicoEspecialItem) : sprintf('%s(%s)', gettype($arrayOfServicoEspecialServicoEspecialItem), var_export($arrayOfServicoEspecialServicoEspecialItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServicoEspecial property can only contain items of type \LGRAVE\StructType\ServicoEspecial, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServicoEspecial value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\ServicoEspecial[] $servicoEspecial
     * @return \LGRAVE\ArrayType\ArrayOfServicoEspecial
     */
    public function setServicoEspecial(array $servicoEspecial = array())
    {
        // validation for constraint: array
        if ('' !== ($servicoEspecialArrayErrorMessage = self::validateServicoEspecialForArrayConstraintsFromSetServicoEspecial($servicoEspecial))) {
            throw new \InvalidArgumentException($servicoEspecialArrayErrorMessage, __LINE__);
        }
        if (is_null($servicoEspecial) || (is_array($servicoEspecial) && empty($servicoEspecial))) {
            unset($this->ServicoEspecial);
        } else {
            $this->ServicoEspecial = $servicoEspecial;
        }
        return $this;
    }
    /**
     * Add item to ServicoEspecial value
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\ServicoEspecial $item
     * @return \LGRAVE\ArrayType\ArrayOfServicoEspecial
     */
    public function addToServicoEspecial(\LGRAVE\StructType\ServicoEspecial $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LGRAVE\StructType\ServicoEspecial) {
            throw new \InvalidArgumentException(sprintf('The ServicoEspecial property can only contain items of type \LGRAVE\StructType\ServicoEspecial, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServicoEspecial[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LGRAVE\StructType\ServicoEspecial|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LGRAVE\StructType\ServicoEspecial|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LGRAVE\StructType\ServicoEspecial|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LGRAVE\StructType\ServicoEspecial|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LGRAVE\StructType\ServicoEspecial|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServicoEspecial
     */
    public function getAttributeName()
    {
        return 'ServicoEspecial';
    }
}
