<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfShipmentToPickUp ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfShipmentToPickUp
 * @subpackage Arrays
 */
class ArrayOfShipmentToPickUp extends AbstractStructArrayBase
{
    /**
     * The ShipmentToPickUp
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\StructType\ShipmentToPickUp[]
     */
    public $ShipmentToPickUp;
    /**
     * Constructor method for ArrayOfShipmentToPickUp
     * @uses ArrayOfShipmentToPickUp::setShipmentToPickUp()
     * @param \LGRAVE\StructType\ShipmentToPickUp[] $shipmentToPickUp
     */
    public function __construct(array $shipmentToPickUp = array())
    {
        $this
            ->setShipmentToPickUp($shipmentToPickUp);
    }
    /**
     * Get ShipmentToPickUp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\StructType\ShipmentToPickUp[]|null
     */
    public function getShipmentToPickUp()
    {
        return isset($this->ShipmentToPickUp) ? $this->ShipmentToPickUp : null;
    }
    /**
     * This method is responsible for validating the values passed to the setShipmentToPickUp method
     * This method is willingly generated in order to preserve the one-line inline validation within the setShipmentToPickUp method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateShipmentToPickUpForArrayConstraintsFromSetShipmentToPickUp(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfShipmentToPickUpShipmentToPickUpItem) {
            // validation for constraint: itemType
            if (!$arrayOfShipmentToPickUpShipmentToPickUpItem instanceof \LGRAVE\StructType\ShipmentToPickUp) {
                $invalidValues[] = is_object($arrayOfShipmentToPickUpShipmentToPickUpItem) ? get_class($arrayOfShipmentToPickUpShipmentToPickUpItem) : sprintf('%s(%s)', gettype($arrayOfShipmentToPickUpShipmentToPickUpItem), var_export($arrayOfShipmentToPickUpShipmentToPickUpItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ShipmentToPickUp property can only contain items of type \LGRAVE\StructType\ShipmentToPickUp, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ShipmentToPickUp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\ShipmentToPickUp[] $shipmentToPickUp
     * @return \LGRAVE\ArrayType\ArrayOfShipmentToPickUp
     */
    public function setShipmentToPickUp(array $shipmentToPickUp = array())
    {
        // validation for constraint: array
        if ('' !== ($shipmentToPickUpArrayErrorMessage = self::validateShipmentToPickUpForArrayConstraintsFromSetShipmentToPickUp($shipmentToPickUp))) {
            throw new \InvalidArgumentException($shipmentToPickUpArrayErrorMessage, __LINE__);
        }
        if (is_null($shipmentToPickUp) || (is_array($shipmentToPickUp) && empty($shipmentToPickUp))) {
            unset($this->ShipmentToPickUp);
        } else {
            $this->ShipmentToPickUp = $shipmentToPickUp;
        }
        return $this;
    }
    /**
     * Add item to ShipmentToPickUp value
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\ShipmentToPickUp $item
     * @return \LGRAVE\ArrayType\ArrayOfShipmentToPickUp
     */
    public function addToShipmentToPickUp(\LGRAVE\StructType\ShipmentToPickUp $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LGRAVE\StructType\ShipmentToPickUp) {
            throw new \InvalidArgumentException(sprintf('The ShipmentToPickUp property can only contain items of type \LGRAVE\StructType\ShipmentToPickUp, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ShipmentToPickUp[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LGRAVE\StructType\ShipmentToPickUp|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LGRAVE\StructType\ShipmentToPickUp|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LGRAVE\StructType\ShipmentToPickUp|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LGRAVE\StructType\ShipmentToPickUp|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LGRAVE\StructType\ShipmentToPickUp|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ShipmentToPickUp
     */
    public function getAttributeName()
    {
        return 'ShipmentToPickUp';
    }
}
