<?php

namespace LGRAVE;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfstring' => '\\LGRAVE\\ArrayType\\ArrayOfstring',
            'DadosRecolhaBE' => '\\LGRAVE\\StructType\\DadosRecolhaBE',
            'MarcarRecolhaReturn' => '\\LGRAVE\\StructType\\MarcarRecolhaReturn',
            'PesquisaRecolhasReturn' => '\\LGRAVE\\StructType\\PesquisaRecolhasReturn',
            'ArrayOfRecolhasListBE' => '\\LGRAVE\\ArrayType\\ArrayOfRecolhasListBE',
            'RecolhasListBE' => '\\LGRAVE\\StructType\\RecolhasListBE',
            'RecolhasListBEExtended' => '\\LGRAVE\\StructType\\RecolhasListBEExtended',
            'GetRecolhaReturn' => '\\LGRAVE\\StructType\\GetRecolhaReturn',
            'RecolhaDadosBE' => '\\LGRAVE\\StructType\\RecolhaDadosBE',
            'ArrayOfProdutosBE' => '\\LGRAVE\\ArrayType\\ArrayOfProdutosBE',
            'ProdutosBE' => '\\LGRAVE\\StructType\\ProdutosBE',
            'ArrayOfEstadosBE' => '\\LGRAVE\\ArrayType\\ArrayOfEstadosBE',
            'EstadosBE' => '\\LGRAVE\\StructType\\EstadosBE',
            'GetAreaInfluenciaReturn' => '\\LGRAVE\\StructType\\GetAreaInfluenciaReturn',
            'ArrayOfServicoEspecial' => '\\LGRAVE\\ArrayType\\ArrayOfServicoEspecial',
            'ServicoEspecial' => '\\LGRAVE\\StructType\\ServicoEspecial',
            'ArrayOfDocumentData' => '\\LGRAVE\\ArrayType\\ArrayOfDocumentData',
            'DocumentData' => '\\LGRAVE\\StructType\\DocumentData',
            'ArrayOfErrorData' => '\\LGRAVE\\ArrayType\\ArrayOfErrorData',
            'ErrorData' => '\\LGRAVE\\StructType\\ErrorData',
            'DDA' => '\\LGRAVE\\StructType\\DDA',
            'DeliveryPointData' => '\\LGRAVE\\StructType\\DeliveryPointData',
            'MultipleHomeDeliveryData' => '\\LGRAVE\\StructType\\MultipleHomeDeliveryData',
            'ReturnAuthorizationData' => '\\LGRAVE\\StructType\\ReturnAuthorizationData',
            'TimeWindowData' => '\\LGRAVE\\StructType\\TimeWindowData',
            'ArrayOfDeliveryNote' => '\\LGRAVE\\ArrayType\\ArrayOfDeliveryNote',
            'DeliveryNote' => '\\LGRAVE\\StructType\\DeliveryNote',
            'ArrayOfShipmentCTT' => '\\LGRAVE\\ArrayType\\ArrayOfShipmentCTT',
            'ShipmentCTT' => '\\LGRAVE\\StructType\\ShipmentCTT',
            'DeliveryAggregationInf' => '\\LGRAVE\\StructType\\DeliveryAggregationInf',
            'ArrayOfPIPAuthorizationData' => '\\LGRAVE\\ArrayType\\ArrayOfPIPAuthorizationData',
            'PIPAuthorizationData' => '\\LGRAVE\\StructType\\PIPAuthorizationData',
            'AddressData' => '\\LGRAVE\\StructType\\AddressData',
            'ShipmentData' => '\\LGRAVE\\StructType\\ShipmentData',
            'CargoData' => '\\LGRAVE\\StructType\\CargoData',
            'CustomsData' => '\\LGRAVE\\StructType\\CustomsData',
            'ArrayOfCustomsItemsData' => '\\LGRAVE\\ArrayType\\ArrayOfCustomsItemsData',
            'CustomsItemsData' => '\\LGRAVE\\StructType\\CustomsItemsData',
            'ArrayOfSpecialService' => '\\LGRAVE\\ArrayType\\ArrayOfSpecialService',
            'SpecialService' => '\\LGRAVE\\StructType\\SpecialService',
            'NewOfferPickUpInput' => '\\LGRAVE\\StructType\\NewOfferPickUpInput',
            'PickUpData' => '\\LGRAVE\\StructType\\PickUpData',
            'ClientData' => '\\LGRAVE\\StructType\\ClientData',
            'ArrayOfPickUpData.Destinations' => '\\LGRAVE\\ArrayType\\ArrayOfPickUpData_Destinations',
            'PickUpAddressData' => '\\LGRAVE\\StructType\\PickUpAddressData',
            'NewOfferPickUpOutput' => '\\LGRAVE\\StructType\\NewOfferPickUpOutput',
            'NewOfferPickUpByPreAvisoInput' => '\\LGRAVE\\StructType\\NewOfferPickUpByPreAvisoInput',
            'NewOfferPickUpByPreAvisoOutput' => '\\LGRAVE\\StructType\\NewOfferPickUpByPreAvisoOutput',
            'CompletePickUpInput' => '\\LGRAVE\\StructType\\CompletePickUpInput',
            'PickUpModel' => '\\LGRAVE\\StructType\\PickUpModel',
            'ArrayOfPickUpModel.Destinations' => '\\LGRAVE\\ArrayType\\ArrayOfPickUpModel_Destinations',
            'CompletePickUpOutput' => '\\LGRAVE\\StructType\\CompletePickUpOutput',
            'ArrayOfShipmentToPickUp' => '\\LGRAVE\\ArrayType\\ArrayOfShipmentToPickUp',
            'ShipmentToPickUp' => '\\LGRAVE\\StructType\\ShipmentToPickUp',
            'MarcarRecolha' => '\\LGRAVE\\StructType\\MarcarRecolha',
            'MarcarRecolhaResponse' => '\\LGRAVE\\StructType\\MarcarRecolhaResponse',
            'PesquisaRecolhas' => '\\LGRAVE\\StructType\\PesquisaRecolhas',
            'PesquisaRecolhasResponse' => '\\LGRAVE\\StructType\\PesquisaRecolhasResponse',
            'GetRecolha' => '\\LGRAVE\\StructType\\GetRecolha',
            'GetRecolhaResponse' => '\\LGRAVE\\StructType\\GetRecolhaResponse',
            'GetProdutosRecolha' => '\\LGRAVE\\StructType\\GetProdutosRecolha',
            'GetProdutosRecolhaResponse' => '\\LGRAVE\\StructType\\GetProdutosRecolhaResponse',
            'GetEstadosRecolha' => '\\LGRAVE\\StructType\\GetEstadosRecolha',
            'GetEstadosRecolhaResponse' => '\\LGRAVE\\StructType\\GetEstadosRecolhaResponse',
            'GetAreaInfluencia' => '\\LGRAVE\\StructType\\GetAreaInfluencia',
            'GetAreaInfluenciaResponse' => '\\LGRAVE\\StructType\\GetAreaInfluenciaResponse',
            'GetZonaTaxacao' => '\\LGRAVE\\StructType\\GetZonaTaxacao',
            'GetZonaTaxacaoResponse' => '\\LGRAVE\\StructType\\GetZonaTaxacaoResponse',
            'NewOfferPickUp' => '\\LGRAVE\\StructType\\NewOfferPickUp',
            'NewOfferPickUpResponse' => '\\LGRAVE\\StructType\\NewOfferPickUpResponse',
            'NewOfferPickUpByPreAviso' => '\\LGRAVE\\StructType\\NewOfferPickUpByPreAviso',
            'NewOfferPickUpByPreAvisoResponse' => '\\LGRAVE\\StructType\\NewOfferPickUpByPreAvisoResponse',
            'CompletePickUp' => '\\LGRAVE\\StructType\\CompletePickUp',
            'CompletePickUpResponse' => '\\LGRAVE\\StructType\\CompletePickUpResponse',
        );
    }
}
