<?php

namespace LGRAVE\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Pesquisa ServiceType
 * @subpackage Services
 */
class Pesquisa extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named PesquisaRecolhas
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \LGRAVE\StructType\PesquisaRecolhas $parameters
     * @return \LGRAVE\StructType\PesquisaRecolhasResponse|bool
     */
    public function PesquisaRecolhas(\LGRAVE\StructType\PesquisaRecolhas $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->PesquisaRecolhas($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \LGRAVE\StructType\PesquisaRecolhasResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
