<?php

namespace LGRAVE\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for New ServiceType
 * @subpackage Services
 */
class _New extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named NewOfferPickUp
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \LGRAVE\StructType\NewOfferPickUp $parameters
     * @return \LGRAVE\StructType\NewOfferPickUpResponse|bool
     */
    public function NewOfferPickUp(\LGRAVE\StructType\NewOfferPickUp $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->NewOfferPickUp($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named NewOfferPickUpByPreAviso
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \LGRAVE\StructType\NewOfferPickUpByPreAviso $parameters
     * @return \LGRAVE\StructType\NewOfferPickUpByPreAvisoResponse|bool
     */
    public function NewOfferPickUpByPreAviso(\LGRAVE\StructType\NewOfferPickUpByPreAviso $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->NewOfferPickUpByPreAviso($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \LGRAVE\StructType\NewOfferPickUpByPreAvisoResponse|\LGRAVE\StructType\NewOfferPickUpResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
