<?php

namespace LGRAVE\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAreaInfluencia StructType
 * @subpackage Structs
 */
class GetAreaInfluencia extends AbstractStructBase
{
    /**
     * The cp4Origem
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cp4Origem;
    /**
     * The cp4Destino
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cp4Destino;
    /**
     * The subproduto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $subproduto;
    /**
     * The cdPaisDestino
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cdPaisDestino;
    /**
     * The SEPS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\ArrayType\ArrayOfstring
     */
    public $SEPS;
    /**
     * Constructor method for GetAreaInfluencia
     * @uses GetAreaInfluencia::setCp4Origem()
     * @uses GetAreaInfluencia::setCp4Destino()
     * @uses GetAreaInfluencia::setSubproduto()
     * @uses GetAreaInfluencia::setCdPaisDestino()
     * @uses GetAreaInfluencia::setSEPS()
     * @param string $cp4Origem
     * @param string $cp4Destino
     * @param string $subproduto
     * @param string $cdPaisDestino
     * @param \LGRAVE\ArrayType\ArrayOfstring $sEPS
     */
    public function __construct($cp4Origem = null, $cp4Destino = null, $subproduto = null, $cdPaisDestino = null, \LGRAVE\ArrayType\ArrayOfstring $sEPS = null)
    {
        $this
            ->setCp4Origem($cp4Origem)
            ->setCp4Destino($cp4Destino)
            ->setSubproduto($subproduto)
            ->setCdPaisDestino($cdPaisDestino)
            ->setSEPS($sEPS);
    }
    /**
     * Get cp4Origem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCp4Origem()
    {
        return isset($this->cp4Origem) ? $this->cp4Origem : null;
    }
    /**
     * Set cp4Origem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cp4Origem
     * @return \LGRAVE\StructType\GetAreaInfluencia
     */
    public function setCp4Origem($cp4Origem = null)
    {
        // validation for constraint: string
        if (!is_null($cp4Origem) && !is_string($cp4Origem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cp4Origem, true), gettype($cp4Origem)), __LINE__);
        }
        if (is_null($cp4Origem) || (is_array($cp4Origem) && empty($cp4Origem))) {
            unset($this->cp4Origem);
        } else {
            $this->cp4Origem = $cp4Origem;
        }
        return $this;
    }
    /**
     * Get cp4Destino value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCp4Destino()
    {
        return isset($this->cp4Destino) ? $this->cp4Destino : null;
    }
    /**
     * Set cp4Destino value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cp4Destino
     * @return \LGRAVE\StructType\GetAreaInfluencia
     */
    public function setCp4Destino($cp4Destino = null)
    {
        // validation for constraint: string
        if (!is_null($cp4Destino) && !is_string($cp4Destino)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cp4Destino, true), gettype($cp4Destino)), __LINE__);
        }
        if (is_null($cp4Destino) || (is_array($cp4Destino) && empty($cp4Destino))) {
            unset($this->cp4Destino);
        } else {
            $this->cp4Destino = $cp4Destino;
        }
        return $this;
    }
    /**
     * Get subproduto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSubproduto()
    {
        return isset($this->subproduto) ? $this->subproduto : null;
    }
    /**
     * Set subproduto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $subproduto
     * @return \LGRAVE\StructType\GetAreaInfluencia
     */
    public function setSubproduto($subproduto = null)
    {
        // validation for constraint: string
        if (!is_null($subproduto) && !is_string($subproduto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($subproduto, true), gettype($subproduto)), __LINE__);
        }
        if (is_null($subproduto) || (is_array($subproduto) && empty($subproduto))) {
            unset($this->subproduto);
        } else {
            $this->subproduto = $subproduto;
        }
        return $this;
    }
    /**
     * Get cdPaisDestino value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCdPaisDestino()
    {
        return isset($this->cdPaisDestino) ? $this->cdPaisDestino : null;
    }
    /**
     * Set cdPaisDestino value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cdPaisDestino
     * @return \LGRAVE\StructType\GetAreaInfluencia
     */
    public function setCdPaisDestino($cdPaisDestino = null)
    {
        // validation for constraint: string
        if (!is_null($cdPaisDestino) && !is_string($cdPaisDestino)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cdPaisDestino, true), gettype($cdPaisDestino)), __LINE__);
        }
        if (is_null($cdPaisDestino) || (is_array($cdPaisDestino) && empty($cdPaisDestino))) {
            unset($this->cdPaisDestino);
        } else {
            $this->cdPaisDestino = $cdPaisDestino;
        }
        return $this;
    }
    /**
     * Get SEPS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\ArrayType\ArrayOfstring|null
     */
    public function getSEPS()
    {
        return isset($this->SEPS) ? $this->SEPS : null;
    }
    /**
     * Set SEPS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \LGRAVE\ArrayType\ArrayOfstring $sEPS
     * @return \LGRAVE\StructType\GetAreaInfluencia
     */
    public function setSEPS(\LGRAVE\ArrayType\ArrayOfstring $sEPS = null)
    {
        if (is_null($sEPS) || (is_array($sEPS) && empty($sEPS))) {
            unset($this->SEPS);
        } else {
            $this->SEPS = $sEPS;
        }
        return $this;
    }
}
