<?php

namespace LGRAVE\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetZonaTaxacao StructType
 * @subpackage Structs
 */
class GetZonaTaxacao extends AbstractStructBase
{
    /**
     * The cdOrigem
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cdOrigem;
    /**
     * The cp4
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cp4;
    /**
     * The subproduto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $subproduto;
    /**
     * The cdPaisDest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cdPaisDest;
    /**
     * Constructor method for GetZonaTaxacao
     * @uses GetZonaTaxacao::setCdOrigem()
     * @uses GetZonaTaxacao::setCp4()
     * @uses GetZonaTaxacao::setSubproduto()
     * @uses GetZonaTaxacao::setCdPaisDest()
     * @param string $cdOrigem
     * @param string $cp4
     * @param string $subproduto
     * @param string $cdPaisDest
     */
    public function __construct($cdOrigem = null, $cp4 = null, $subproduto = null, $cdPaisDest = null)
    {
        $this
            ->setCdOrigem($cdOrigem)
            ->setCp4($cp4)
            ->setSubproduto($subproduto)
            ->setCdPaisDest($cdPaisDest);
    }
    /**
     * Get cdOrigem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCdOrigem()
    {
        return isset($this->cdOrigem) ? $this->cdOrigem : null;
    }
    /**
     * Set cdOrigem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cdOrigem
     * @return \LGRAVE\StructType\GetZonaTaxacao
     */
    public function setCdOrigem($cdOrigem = null)
    {
        // validation for constraint: string
        if (!is_null($cdOrigem) && !is_string($cdOrigem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cdOrigem, true), gettype($cdOrigem)), __LINE__);
        }
        if (is_null($cdOrigem) || (is_array($cdOrigem) && empty($cdOrigem))) {
            unset($this->cdOrigem);
        } else {
            $this->cdOrigem = $cdOrigem;
        }
        return $this;
    }
    /**
     * Get cp4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCp4()
    {
        return isset($this->cp4) ? $this->cp4 : null;
    }
    /**
     * Set cp4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cp4
     * @return \LGRAVE\StructType\GetZonaTaxacao
     */
    public function setCp4($cp4 = null)
    {
        // validation for constraint: string
        if (!is_null($cp4) && !is_string($cp4)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cp4, true), gettype($cp4)), __LINE__);
        }
        if (is_null($cp4) || (is_array($cp4) && empty($cp4))) {
            unset($this->cp4);
        } else {
            $this->cp4 = $cp4;
        }
        return $this;
    }
    /**
     * Get subproduto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSubproduto()
    {
        return isset($this->subproduto) ? $this->subproduto : null;
    }
    /**
     * Set subproduto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $subproduto
     * @return \LGRAVE\StructType\GetZonaTaxacao
     */
    public function setSubproduto($subproduto = null)
    {
        // validation for constraint: string
        if (!is_null($subproduto) && !is_string($subproduto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($subproduto, true), gettype($subproduto)), __LINE__);
        }
        if (is_null($subproduto) || (is_array($subproduto) && empty($subproduto))) {
            unset($this->subproduto);
        } else {
            $this->subproduto = $subproduto;
        }
        return $this;
    }
    /**
     * Get cdPaisDest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCdPaisDest()
    {
        return isset($this->cdPaisDest) ? $this->cdPaisDest : null;
    }
    /**
     * Set cdPaisDest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cdPaisDest
     * @return \LGRAVE\StructType\GetZonaTaxacao
     */
    public function setCdPaisDest($cdPaisDest = null)
    {
        // validation for constraint: string
        if (!is_null($cdPaisDest) && !is_string($cdPaisDest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cdPaisDest, true), gettype($cdPaisDest)), __LINE__);
        }
        if (is_null($cdPaisDest) || (is_array($cdPaisDest) && empty($cdPaisDest))) {
            unset($this->cdPaisDest);
        } else {
            $this->cdPaisDest = $cdPaisDest;
        }
        return $this;
    }
}
